import java.awt.*;
import java.awt.event.*;
import java.rmi.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.rmi.registry.*;


public class Irc extends Frame {
	public TextArea		text;
	public TextField	data;
	SharedObject		sentence;
	static String		myName;

	public static void main(String argv[]) {
		
		/*
		if (argv.length != 1) {
			System.out.println("java Irc <name>");
			return;
		}*/
		myName = "debug";
	
		System.out.println("Initialisation");
		
		// initialize the system
		Client.init();
		
		// look up the IRC object in the name server
		// if not found, create it, and register it in the name server
		
		SharedObject nb = Client.lookup("nb");
		if (nb == null) {
			System.out.println("L'objet n'existe pas. Création");
			nb = Client.create(new Nombre());
			Client.register("nb", nb);
		}
		
		SharedObject s = Client.lookup("IRC");

		if (s == null) {
			System.out.println("L'objet n'existe pas. Création");
			s = Client.create(new Sentence2(nb));
			Client.register("IRC", s);
		}
		// create the graphical part
		new Irc(s);
	}

	public Irc(SharedObject s) {
	
		setLayout(new FlowLayout());
	
		text=new TextArea(10,60);
		text.setEditable(false);
		text.setForeground(Color.red);
		add(text);
	
		data=new TextField(60);
		add(data);
	
		Button write_button = new Button("write");
		write_button.addActionListener(new writeListener(this));
		add(write_button);
		Button read_button = new Button("read");
		read_button.addActionListener(new readListener(this));
		add(read_button);
		
		setSize(470,300);
		text.setBackground(Color.black); 
		show();
		
		sentence = s;
	}
}



class readListener implements ActionListener {
	Irc irc;
	public readListener (Irc i) {
		irc = i;
	}
	public void actionPerformed (ActionEvent e) {
		
		// lock the object in read mode
		irc.sentence.lock_read();
		
		// invoke the method
		String s = ((Sentence2)(irc.sentence.obj)).read();
		
		SharedObject nb = ((Sentence2)(irc.sentence.obj)).n;
		
		if (nb == null){
			System.out.println("le nb EST NULL !!!!");
		}
		
		nb.lock_read();
		
		Nombre nbre = ((Nombre)nb.obj);
		if (nb.obj == null){
			System.out.println("le nb.obj EST NULL !!!!");
		}
		System.out.println("nb vaut : "+ nbre.read());
		
		nb.unlock();
		
		// unlock the object
		irc.sentence.unlock();
		
		// display the read value
		irc.text.append(s+"\n");
	}
}

class writeListener implements ActionListener {
	Irc irc;
	public writeListener (Irc i) {
        	irc = i;
	}
	public void actionPerformed (ActionEvent e) {
		
		// get the value to be written from the buffer
        	String s = irc.data.getText();
        	
        	// lock the object in write mode
		irc.sentence.lock_write();
		
		// invoke the method
		((Sentence2)(irc.sentence.obj)).write(Irc.myName+" wrote "+s);
		irc.data.setText("");
		
		SharedObject nb = ((Sentence2)(irc.sentence.obj)).n;
		
		nb.lock_write();
		
		((Nombre)nb.obj).entier ++;
		
		nb.unlock();
		
		// unlock the object
		irc.sentence.unlock();
	}
}



